What's New :
------------

v1.36
       - Fixed Gunforce, added invalid HDMA modes. [_Demo_]
         (Thanks Overload!)
       - New BRR decoding method, this should resolve all the sound
         issues introduced in 1.35 and fix new ones.
         (Noise simulation isn't used anymore) [_Demo_]
       - Fixed another bug with command-line netplay. (Windows only)
         [pagefault]
       - Fixed hang in NBA Live 95 and 96. [_Demo_] (Thanks Overload!)
       - Fixed sound not working on first run. (Windows only) [pagefault]
       - Fixed some more mode 4 issues in the new gfx engine. [pagefault]
       - Added offset mode disable toggle to 8-bit new gfx engine.
         [pagefault]
       - Fixed SPC hang in 90 Minutes European Prime Goal
         by clearing spcram. [_Demo_]
       - Updated fix for Clayfighter to fix some bugs in battle. [_Demo_]
       - Fixed crash with certain games. (SDL/*nix only) [theoddone33]
       - Added better OBC1 detection. [_Demo_]
       - Special hack for Samurai Showdown IRQ problem. [_Demo_]
       - Special hack for Kamen Rider menu, requires special latch reading.
         [_Demo_]
       - Special hack for Super Famista 1 & 2 SPC bugs. [_Demo_]
       - Fixed some more bugs in video code. (Thanks Perryman for the video
         table) (Windows only) [pagefault]
       - Fixed Digital Devil Story hang by modifying the spc code.
         You must start a new game for the fix to work. [_Demo_]
       - Modified work ram init value to 0x55. (Thanks TRAC)

v1.35
       - Fixed triple buffering corruption on some VESA 2.x video modes,
         a very nasty bug which accidentally slipped into version 1.337.
         [stainless] (DOS only)
       - Added full scanlines to 320x256x8b Mode-X.  Uses the same timings
         as the 256x256x8b full scanlines, so it may or may not work
         correctly depending on your video card.
         [stainless] (DOS only)
       - Linked the EAGLE engine to the filtered GUI option and fixed
         guassian interpolation which has been broken since version 1.71b.
         [stainless, kode54] (DOS only/all ports)        
       - Cleaned up the 320x480x8b and 320x240x16b blitters and added
         MMX support to 320x480x8b for a nice speed increase.
         [stainless] (DOS only)        
       - Added 640x400 alternatives to 512x384 video modes for video
         cards which don't have them.  Added a small screen option to
         the 512x384 and 640x400 video modes with MMX support.  Also
         added a "wide screen" option to 640x400 video modes.
         [stainless] (DOS only)        
       - Added a full screen option to the 320x480 video modes, along
         with a basic interpolation to 320x240x16b and 320x480x16b
         Full screen in 320x480x16b has full/25%/50% scanlines and
         interpolation has full scanlines.
         [stainless] (DOS only)        
       - Added experimental 800x600 video modes.  Fixed 'n' command-line
         option to allow toggling of 25%/50% in addition to full, also
         cleaned up the command-line options message and the config file.
         Noticed some video modes were way off-centered, fixed that
         too, should now be perfect.
         [stainless] (DOS only)        
       - Fixed printing of MMX enabled message on the GUI background if
         you checked MMX SUPPORT under CONFIG -> OPTIONS.  Also, if you
         check MMX SUPPORT by using the keyboard shortcut it will now
         attempt to actually detect MMX before enabling it. :)
         [stainless, pagefault] (DOS only)        
       - Command line support in windows port [StatMat]        
       - Fixed problem when some video modes were not being saved. (Windows
         only) [pagefault]
       - Lots of updates to Linux/SDL version, including sound fixes, video
         code updates and other misc bugs. [theoddone33, Thorsten Glaser,
         Wilbern Cobb]
       - Fixed gamma in PNG snapshots. [pagefault]
       - Added several new goodies to the GUI, which include a force
         8-bit sound option (fixes a few cards under WinMe), a second
         water effect, and an experimental smoke effect.
         [stainless] (DOS only/all ports)        
       - Fixed problem with sound getting disabled when running command-line
         network games. (Windows only) [pagefault]
       - Updated video code in Windows port to properly display 239 line
         modes. (Windows only) [pagefault]
       - Commented, unified, and cleaned up the Mode-Q and Mode-X
         blitters.  I did a major overhaul to the DOS video code, I cleaned
         up and reorganized it alot, and there seem to be no problems as of
         yet. [stainless, TRAC] (DOS only)        
       - Fixed a bug in sprite priority rotation. (fix damage in FFMQ) [TRAC]        
       - Fixed long delay between battles and fixed flickering colours
         on map in Front Mission. [pagefault]        
       - Fixed hang when picking up apples in Equinox. [pagefault]        
       - Fixed keyon bug in DSP code, fixes sounds in Flaskback 3
         Language Edition (Thanks neviski) [_Demo_]        
       - Fixed "disco colours" in NBA Hangtime when the ball drops.
         [pagefault]
       - Fixed an NMI issue with register $4212, fixes hang in Cu-On-Pa,
         Bubsy and others. [pagefault]        
       - Fixed a mode 4 bug in the new graphics engine that was causing
         the title screen in The Lost Vikings to be scrambled. [pagefault]        
       - Added support for Super System arcade system, set DIP switches
         in add-on's menu in GUI. Games MUST be zipped in order to load.
         [pagefault]
       - Added special support for Earthworm Jim 2 sound effects. [_Demo_]        
       - Added hack for Deaetonosama Apareitiban. [_Demo_]        
       - Fixed super scope position reading. [_Demo_]        
       - Modified a few timing things. [_Demo_]        
       - Fixed some 65816 instructions in processor emulation mode. [_Demo_]        
       - Added special timing for Grand Prix 3. [_Demo_]        
       - Modified sound decoding another time (helps various noise
         sounds like DQ6). [_Demo_]        
       - Modified joypad reading for VS Collection. [_Demo_]        
       - Special modification for Bahamut Lagoon and Clay Fighter to
         delay write to the hdma register. (those games need dma delay
         implemented) [_Demo_]        
       - Lots of other minor fixes and things we forgot to mention.


v1.337 - This release is dedicated to zsKnight and his family

       All ports
       ---------
       - Added a customizable key to toggle display of the game clock
         [pagefault]
       - Added support for up to 100 SPC file saves per game [pagefault]
       - Added customisable keys to increment and decrement the save state
         slot [pagefault]
       - Added a customisable key to quickly save an SPC file [pagefault]
       - Added force NTSC/PAL and force HiROM/LoROM options to GUI
         [pagefault]
       - Added a customisable key to toggle the display of the FPS counter
         [pagefault]
       - Added keyboard shortcuts to video options menu [pagefault]
       - Added feature to automatically increment save state slot after each
         save [pagefault]
       - Added new 8-point sound interpolation and two new lowpass filters
         (requires a fast processor, 8pt interpolation and high quality
         lowpass requires an MMX processor) [kode54]
       - Fixed an annoying bug when the menu selection bar would be floating
         in thin air (Thanks to EMu LoRd for pointing this out) [pagefault]
       - Fixed MMX toggle option, now saved when you restart ZSNES
         [pagefault]
       - Fixed freeze/crash when saving SPC files [pagefault]
       - Fixed filtered GUI option with 2xSaI enabled not refreshing the
         screen [pagefault]
       - Fixed graphics when reseting a game with 2xSaI engine on and the FPS
         counter and/or game clock on [pagefault]
       - Fixed Vortex, Clayfighter 2, Mr. Nutz, Tenchi Wo Kurau Sangokushi
         Gunyuden and others now working again [_Demo_]
       - Fixed Umi Hara Kawa Se and Tin Tin in Tibet [_Demo_]
       - Fixed LoROM/HiROM detection code, Star Trek: Deep Space Nine and
         possibly others now working [pagefault]
       - Fixed Front Mission: Gun Hazard and Pocky and Rocky, now working
         again [_Demo_]
       - Fixed Neugier and Battle Grand Prix freezing after a certain point
         in the game. [_Demo_]
       - Fixed bug in rom header information and checksum status display,
         fixes Tales of Phantasia and others [pagefault]
       - Fixed Marko's Magical Football copy protection [pagefault]
       - Fixed problem with Filtered GUI enabled and parts of game screen
         would show up in GUI menus [pagefault]
       - Fixed frameskip command-line offset [pagefault]
       - Fixed Sim Earth, now loads but map is still not visible [_Demo_]
       - Fixed crash in Home Alone when starting a new game [_Demo_]
       - Fixed sprites in Super James Pond 2 and Kirby Avalanche (Thanks
         Snes9X for the info) [_Demo_]
       - Fixed 256x239 SNES resolution offset in Windows and Linux ports,
         games that use this resolution should now be displayed properly in
         these ports [_Demo_]
       - Fixed freeze in Accelebrid after a few seconds of gameplay [_Demo_]
       - Fixed cursor getting messed up in Windows and Linux ports when using
         a 16-bit desktop [_Demo_]
       - Fixed bugs when switching between fullscreen and windowed modes with
         fullscreen button in Windows and Linux port [pagefault]
       - Fixed Triple Buffering and vsync options so they can't be enabled at
         the time (Triple buffering includes vsync automatically) [pagefault]
       - Fixed sprite layer disappearing when changing screenshot formats or
         moving the F1 menu [pagefault]
       - Fixed a clipping offset bug in the new gfx engine [pagefault]
       - Fixed BG3 issue with sub-screens in new graphics engine, fixes gfx
         in Bahamut Lagoon's intro and lots of other games [pagefault]
       - Fixed timing problem in Clock Tower that caused it to freeze
         randomly in-game, implemented a hack for now [pagefault]
       - Fixed Cu-On-Pa freezing when starting a new game (Thanks to Lordtech
         for the help) [_Demo_]
       - Optimised global code base, most people should see a performance
         increase [pagefault, stainless]
       - Moved vsync option from game options menu to video options
         [pagefault]
       - Improved S-DD1 decompressed pack loading and execution, increases
         performance in S-DD1 decompressed pack games [pagefault]
       - Lots of debugger fixes and additions [byuu, bongo]
       - Removed disable screensaver text from DOS and Linux ports
         [pagefault]
       - Updated water effect code to using lighting effects
         [stainless, kode54]
       - Improved SPC700 sample processing, fixes sounds in numerous games
         [_Demo_]
       - Disabled H-DMA for Bahamut Lagoon and Mortal Kombat, fixes some gfx
         problems [pagefault]
       - Changed default keyboard layout for player 2 as some keys were
         overlapping player 1 (Oops!), If you were having problems buying
         things in FF4 or in other games make sure to change your keys for
         player 2. [pagefault]
       - Cleaned up config file in Windows and Linux ports, removed DOS
         related comments [pagefault]
       - MMX option now checks for a MMX processor when enabling it in the
         GUI, also no longer crashes on processors without a cpuid when
         detecting MMX [pagefault, kode54]
       - Last netplay IP address used is now saved in Windows and Linux ports
         [pagefault]
       - Reorganized sound menu; removed sound interpolation checkbox and
         made a new list of different types of interpolation: gaussian
         (original interpolation with enable interpolation option), cubic
         spline and 8-point interpolation. Also made a new list of lowpass
         filters. [pagefault]
       - Removed FPU copy from -? option on command line message, since it is
         no longer supported. Also cleaned up that message in general
         [stainless]
       - FPS at program start option no longer enables FPS display when auto
         framerate is not enabled [pagefault]
       - Updated video interpolation code, now looks better than before
         [kode54]
       - Lots of misc GUI fixes and cosmetic tweaks [pagefault]
       - (UPDATE) Added surround sound to Windows and Linux ports, updated
         filter in DOS port (This was left out of the previous whatsnew
         file) [kode54]

       DOS v1.337
       ----------
       - Added grayscale mode toggle to GUI [pagefault]
       - Added support for 5 SNES gamepads on LPT1 [ZDrumm]
       - Added two new 256 color linear VGA video modes, 256x224 and 256x240
         [stainless]
       - Added proper gamma correction, now ranges from 0 (1.0) to 15 (~2.0)
         in 8bpp modes [stainless]
       - Fixed Filtered GUI option, now works [pagefault]
       - Fixed full scanlines disappearing in some modes [pagefault]
       - Fixed a handful of bugs in the joystick code which may cause the
         joystick not to work if it has a driver installed under Win9x
         control panel [stainless]
       - Fixed date problem in S-RTC games not reporting the proper day of
         the week [stainless]
       - Fixed issue with some sound blaster compatible cards not working
         properly in the DOS port [kode54]
       - Reordered video modes in alphabetical order [stainless]
       - Improved SNES pad reading routine, any speed hit now should be
         minimum when using a snespad adaptor [pagefault]
       - Improved interpolation performance [stainless]
       - Default keys for player 1 are now the same as Windows and Linux
         ports [pagefault]
       - You can now use / in command line options in addition to the
         previous - character [stainless]

       Win v1.06
       ---------
       - Added option to toggle the trap mouse cursor feature which prevents
         the mouse cursor from leaving the window by accident [pagefault]
       - Added 640x480 DS WIN; 1024x768 DR FULL; 1280x960 S/DS WIN, S FULL;
         1280x1024 DR/R/DS WIN and FULL resolutions [pagefault]
       - Added a more meaningful message when changing to a resolution isn't
         supported [pagefault]
       - Fixed problem with SRAM not being saved when pressing ALT-F4 in game
         [pagefault]
       - Updated icon yet again, looks really nice. [enigMa]
       - Fixed possible crash when exiting [pagefault]
       - Fixed bug when scrolling in scrollboxes in the GUI would not trap
         the mouse cursor inside the scrollbox like the DOS port does
         [pagefault]
       - Either alt key can now be used when using the alt-enter combination
         to switch to fullscreen [pagefault]
       - Removed triple buffering option from windowed video modes (it does
         not work in windowed mode) [pagefault]
       - Optimised some Windows port specific code, should give a small speed
         boost for most people [pagefault]
       - Rewrote mouse input code, much more efficient now. [pagefault]
       - Reordered video modes in alphabetical order; removed 64x52 and
         128x112 resolutions (Thanks to Terrorcide and McGuiver for helping
         me test this out) [pagefault]
       - Improved performance in 32bpp windowed modes [pagefault]
       - Rewrote some of the audio code to be much more efficient, also added
         MMX optimisations [pagefault, kode54]
       - When switching to windowed mode from fullscreen, the window position
         is now remembered [pagefault]
       - Removed large sound buffer and exclusive mode option, they shouldn't
         be needed anymore [pagefault]
       - Now uses idle task priority when in GUI and window is not active,
         should also smooth task swtiching on slower computers [pagefault]
       - (UPDATE) Fixed server IP bug when using zbattle.net or command-line
         options to connect [pagefault]

       Linux v0.37
       -----------
       - Added autoconf support for easy compiling [Diablo-D3, amit,
         theoddone33]
       - Fixed sound buffering in linux port to improve sound on some cards
         [Diablo-D3]
       - Implemented S-RTC time functions, FEoEZ and other S-RTC games will
         now report system time in game [pagefault]
       - Now supports compiling with gcc 3.0.0 [EvilTypeGuy]

v1.31b
       All ports
       ---------
       - Fixed Super Punchout, now working [zsKnight, _Demo_]
       - Fixed SD Gundam GNext again [_Demo_]
       - Final Fantasy Mystic Quest now works again [zsKnight]

       Win v1.04
       ---------
       - Fixed grayscale toggle [pagefault]
       - Updated icon again for black backgrounds [enigMa]

       Linux v0.31
       -----------
       - Now compiles and runs on QNX6 systems [TheAlien]

v1.31
       All ports
       ---------
       - Fixed Mode 4 offset bug (Fixes Bust-A-Move, Puzzle Bobble
         possibly others) [zsKnight]
       - Emerald Dragon is now working [_Demo_]
       - Fixed Last Bible 3 DMA problem (Thanks to SNES9x for the info)
         [_Demo_]
       - Fixed Super Robot Was Ex (Thanks again to SNES9x for the help
         on this) [_Demo_]
       - Moved disable SPC emulation option to sound menu where it should
         be [pagefault]
       - Fixed Wizardry 4 and Honkakuha Igo Gosei, interleaved
         funny [_Demo_]
       - SD Gundam GNext no longer crashes ZSNES, and actually is
         playable now. [_Demo_]
       - Spindizzy worlds should work again [_Demo_, zsKnight]
       - Dezaemon sprites working now, had to clear OAM address when first
         address byte is written to [zsKnight]
       - Power Rangers the Movie working, was reading from register
         2144 [_Demo_]
       - King of Rally now working [_Demo_]
       - Emerald Dragon working, added a hack to disable ENVx for
         that game [_Demo_, zsKnight]
       - Full Throttle Racing working, fixed a bug with the wai
         65816 instruction [_Demo_, zsKnight]
       - Renamed black and white mode to grayscale mode [pagefault]
       - Got Traverse Starlight and Prairie to go further, but it
         still freezes after several scenes [zsKnight]
       - Mario RPG minecart Mode 2 scene working better now [zsKnight]

       Win v1.03
       ---------
       - Added disable screensaver feature to disable screen saver while
         ZSNES is active [pagefault]
       - Fixed yet another DirectInput slowdown [pagefault]
       - Added joystick POV hat support (Thanks to kode54 for testing and
         fixing my code) [pagefault, kode54]
       - Added error messages and directions if DirectX 8.0 is not installed
         [kode54]
       - Fixed another Windows 2000 freeze on exit bug [pagefault]
       - Fixed BSOD when loading roms on some systems [pagefault]
       - Hopefully fixed a crash when multiple roms where in a single zip
         file (only one rom can be loaded per zip file) [pagefault]
       - Fixed a possible crash when loading/continuing a game (Thanks to
         Metus for pointing this out) [pagefault]

       Linux v0.29
       -----------
       - No changes

v1.30b
       All ports
       ---------
       - Support for Star Ocean S-DD1 decompressed pack is now
         enabled. [zsKnight]
       - Fixed bug in H-DMA code, fixes Hook and Bugs Bunny and maybe others
         (Thanks to Gary of Snes9X for help on this) [_Demo_]
       - Updated documentation [Matt Kendora]
       - Fixed new gfx mode checkbox in options menu [pagefault]

       Win v1.02
       ---------
       - Added 800x600 DR FULL mode (scroll down to the bottom of the mode
         list to see it)
       - Fixed timing problem in games when 58 seconds was 1 minute in
         ZSNES [kode54, pagefault]
       - Fixed voices in ToP opening and Star Ocean [pagefault]
       - Fixed another DirectInput slowdown [pagefault]
       - Fixed joystick 5, it should be working now [pagefault]
       - Optimised code some more, giving 3-5 FPS boost on most
         systems [pagefault]

v1.30
       All ports
       ---------
       - Bubsy 2 working again [zsKnight]
       - Batman: the return of the joker working now [_Demo_]
       - Sound Novel T-Cool and Derby Stallion 96 memory mapper added [_Demo_]
       - Fixed BRR block header bug (fixes Raiden Densetsu, Chrono Trigger,
         Gundam Wing: Endless Duel, and a few other games) [_Demo_]
       - Updated documentation [Matt Kendora]
       - New whatsnew.txt format [pagefault]

       Win v1.01
       ---------
       - Updated icon [enigMa]
       - Added 1280x960 DR, DR FULL modes to Windows port [pagefault]
       - Fixed random crash when loading roms in Windows port [pagefault]
       - Rewrote resolution switching code [pagefault]
       - Window now moves much smoother and faster [pagefault]
       - Readded large sound buffer option [pagefault]
       - Fixed CPU usage when window was minimized [pagefault]
       - Fixed multiple instances when window was minimized [pagefault]

       Linux v0.29
       -----------
       - OpenGL support [hpsolo]
       - Bilinear option (w/ filtered GUI) [hpsolo]
       - Fixed video mode descriptions (zsnesl.cfg) [hpsolo]
       - Resizable windows [amit]
       - Filter options (scanlines, 2xSaI, etc) for OpenGL modes [zinx]
       - Many more video modes for OpenGL, including full screen [hpsolo]
       - Joystick POV hat support [hpsolo]
       - Added support for 5th Joystick [hpsolo]

v1.29, Win v1.00
      - Implemented triple buffering in full screen mode (Huge thanks to
        whatabubba for his help on this and cleaning up the code)
        [whatabubba, pagefault]
      - Fixed top 8 lines being invisible of FFMQ [zsKnight]
      - Optimised DirectDraw code some more giving a 10-15% speed increase
        [pagefault]
      - Fixed black screen when switching windows [pagefault]
      - Improved loading and shutdown time [pagefault]
      - Rock 'N Roll Racing is working again [zsKnight]
      - Fixed Lennus 2's sprites [zsKnight]
      - Almost figured out Wizardry 4's rom format.  It seems like this game
        was incorrectly dumped so everything in it is out of order. [zsKnight]
      - Final Fight 2 is working again [zsKnight]
      - Vsync option now works in triple buffering mode [pagefault]
      - Now shows minimize window animation when minimizing [pagefault]
      - Fixed mouse pointer under full screen mode [kode54]
      - New ZSNES icon in Windows port (Thanks for all your entries) [enigMa]

v1.28b, Win v0.99
      - Added a filtered GUI option to allow graphics engines such as 2xSaI
        to be used in the GUI [zsKnight]
      - Fixed SA-1 save states [zsKnight]
      - Fixed Breath of Fire crashing bug when loading [theoddone33]

v1.28, Win v0.99
      - Added option to allow multiple instances of ZSNES (off by default)
        [pagefault]
      - Fixed Lufia 2 sprite disappearing bug [zsKnight]
      - Fixed quick menu crash problem when the entries other than the
        first one is selected when the load menu is opened [zsKnight]
      - Modified SPC700<->65816 timing again to get Hook working [zsKnight]
      - Added more keyboard shortcuts to GUI [pagefault]
      - Fixed vram read to get Smash Tennis working again [zsKnight]
      - Hopefully fixed lockup when exiting Windows port [pagefault]
      - Added a spc700 timing hack for Super Final Match Tennis until I
        re-write the timing engine later (but not anytime soon though)
        [zsKnight]
      - Kinda got Rendering Ranger 2 to go further, but this game seems to
        use some picky timing, so this will have to wait until I re-write
        timing in the future. [zsKnight]
      - Removed large sound buffer option since it wasn't really useful
        [pagefault]
      - Fixed 16bit access to address $001FFF (or equivalent).  Fixes Super
        Tetris 2+Bombliss. [zsKnight]
      - Implemented 128KB sram support.  Dezaemon runs now (but it
        suffers graphics glitches at the moment) [zsKnight]
      - Fixed Wordtris (reading from 002100) [zsKnight]
      - Fixed reset function in William's Arcade Classics [zsKnight]
      - Tuff-E-Nuff works now (another timing hack *sigh* )
      - Added exclusive DirectSound mode option [pagefault]
      - Fixed corrupt graphics in Rock'n Roll racing (reading from invalid
        memory) [zsKnight]
      - Added alternate timer for people having problems with zsnes running
        too fast [bootgod,pagefault,zsKnight]
      - Fixed corrupt graphics in Captain America (also reading from invalid
        memory) [zsKnight]
      - Implemented latest save state selection in Windows port [pagefault]
      - Added v-sync to Windows port (enable in options to use it, should
        fix most graphical tearing issues) [pagefault]
      - Fixed mid-screen OAM updating.  Uniracers works in 2 player mode.
        [zsKnight]
      - Combined the new header detection method with the old one, producing a
        much better method [zsKnight]
      - Added SA-1 read/write to BWRAM bitmap mode in the lower banks
        [zsKnight]
      - Fixed "freeze data" text [hpsolo]
      - Fixed SA-1 write to BWRAM bitmap mode.  It seems like this was the
        main cause of the level-up screen not working in Mario RPG. [zsKnight]
      - Fixed cpu usage when ZSNES is in the background doing nothing
        [pagefault]
      - Re-wrote character conversion 1 for 2bpp, implemented cc1 for 4bpp
        [zsKnight]
      - Fixed vertical high resolution mode for tile priority 1 [zsKnight]
      - Fixed Terranigma overworld glitch in the new graphics engine 16bit
        engine [zsKnight]
      - Enabled RTC in Windows port [pagefault]
      - Moved the Transparent Message option from the Options to the GUI
        Optns section. [pagefault]
      - Added Trainered rom support [zsKnight]
      - Fixed BG4 graphics in certain games (fixes Digital Devil Story)
        [zsKnight]


v1.26, Win v0.97
      - OBC1 support broke in a recent CVS update.  Fixed now. [zsKnight]
      - Added full scanlines to the Win/Linux port [zsKnight]
      - Added Mouse Wheel switch [zsKnight,pagefault]
      - Fixed problem with interpolation/2xSaI/scanlines being saved
        in the windows port [zsKnight]
      - Improved 512 byte header support.  This should improve compatibility
        with some games [zsKnight]
      - Added 768x672 and 1024x896 DR, R windowed video modes to Windows
        port [pagefault]
      - Windows port now uses the primary DirectSound buffer [pagefault]
      - Modified 65816<->SPC700 timing.  I hope this doesn't break
        anything [zsKnight]
      - Fixed a vram read behavior problem (fixed Equinox dungeons) [zsKnight]


v1.25, Win v0.93
      - Fixed cheat menu text when game was not loaded [pagefault]
      - Fixed unlabed checkbox in DOS port [pagefault]
      - DSP1 - Fixed plane controls in Pilotwings [_Demo_]
      - dosintrf.asm - Fixed header detection in the dos port [zsKnight]
      - gui.asm - Video mode checking done at initialization [zsKnight]
      - Enabled mouse wrap in the Windows and Linux ports [pagefault]
      - Fixed full screen mode switch when the user starts ZSNESw before
        selecting any full screen modes [zsKnight]
      - Made default video mode 512x448 windowed in Windows port [pagefault]
      - Prevented enter key from affecting gameplay on returning from
        F1 and F3 menus [zsKnight]
      - Added minimize button to the Windows port [pagefault]
      - Added always on top option in GUI options menu [pagefault]
      - Menu fix for 8bit graphics modes [zsKnight]
      - ZSNESW now remembers the window position on your desktop (can be
        disabled in GUI options) [pagefault]
      - Fixed crashing problem with some IPS's in ZIP's [Teuf, zsKnight]
      - Ported to DirectX 8.0 which fixed some problems and improved performance
        (DirectX 8.0 is now required to run ZSNESW) [pagefault]
      - DSP1 - Fixed map offset problem in Pilotwings [zsKnight]
      - DSP1 - Fixed rings being mysteriously passed problem in Pilotwings [zsKnight]
      - Fixed DirectSound crash when a normal priority buffer could not be
        acquired [pagefault]
      - Fixed DirectInput compatibility on some computers [pagefault]
      - Optimized DSP1 code for better performance [teuf]
      - Added proper full main/sub-screen window clipping in the new gfx 16bit
        engine (fixed Illusion of Gaia/DKC2 selection screens, etc) [zsKnight]
      - Added checksum/header name/chip type header display upon game load [zsKnight]
      - Added PNG snapshot support which is selectable in the F1 menu [Matt Kendora]
      - Stunt Race FX old graphics engine force fixed [zsKnight]
      - Fixed MegamanX copy protection schemes [zsKnight, Matthew Kendora]
      - Fixed TopGear 2 PAL version from detecting a PAL system [zsKnight]
      - Implemented OBC1 chip (for Metal Combat) [zsKnight]
      - Fixed Mode 7 bug in Super Ghouls and Ghosts [zsKnight]
      - Added turbo keys for L & R keys [zsKnight]
      - OBC1 emulation support.  Metal Combat works! [zsKnight]
      - You can now customizable the colors to the title bar and
        window colors. [zsKnight]
      - Optimised global code to provide up to a 50% speed increase on it on most
        processors [pagefault]
      - Added black and white mode to Windows and Linux ports [pagefault]
      - ZSNESW is now packed with the newest version of UPX [pagefault]
      - Cleaned up the cfg files for windows/linux ports [pagefault]
      - Fixed command-line crash in the Windows port (Thanks Matt Kendora) [pagefault]
      - Save/Load state now displays which state is being loaded [hpsolo]
      - Added double buffering support to Linux port [teuf]


v1.20b, Win v0.88
      - Final Fantasy Mystic Quest works again.
      - Fixed Empire Strikes Back crashing bug in the millenium falcon
        sequence (hopefully this will fix some other games too)
      - Removed all self-modifying code in ZSNES.  This will make ZSNES crash
        a lot less on certain systems, especially during mode 7 sequences.
        Thanks Ivar!
      - Implemented S-RTC chip, using the system clock as the actual
        time (The game will make you set the time though, but it will just
        be replaced with the system time in-game).  Thanks to John Weidman and
        Dark Force for the info on this chip!
      - Fixed crashing bug in certain mosaic scenes (eg. FF3 Phantom Forest)
        in the new graphics engine
      - Fixed a nasty crashing/corruption bug in the new graphics engine
        (both 8bit and 16bit)
      - SPC7110 emulation!  This is based on the information reverse
        engineered by the hard working folks at dejap translations,
        Dark Force and John Weidman.
      - Altered HiROM/LoROM detection a bit - Fievel goes West works now
      - Open source preparations [teuf]
      - In-game clock working for the windows port.  [kode54]
      - Fixed a memory leak problem in the new graphics engine [TRAC]
      - Added Cubic Spline Interpolation [Anti Resonance]
      - Fixed a assign/compare size bug in the new graphics engine [TRAC]
      - Fixed b flag setting in BRK instruction in 6502 emulation mode
        [zsKnight]
      - Added SPC7110 logger file output to help in the filesize clipping of
        the SPC7110 data files [zsKnight]
      - Fixed a memory leak bug, fixing that nasty Win2K crash bug
        [Matthew Kendora]
      - Fixed key combination release [Maxim]
      - Fixed source code warnings/added necessary includes [Maxim]
      - Added high priority mode for Windows 2000 users and slower
        computers (works on Windows 9x as well) [pagefault]
      - Added large sound buffer option for people having DirectSound
        problems. [pagefault]
      - Fixed problem with ZSNESW and Opera causing a BSOD. [pagefault]
      - Fixed up error reporting for people experiencing problems. [pagefault]
      - Improved performance on 3dfx cards by compiling with DirectX 8
        SDK. [pagefault]
      - Fixed a sound problem with people with messed up config files.
        [pagefault]
      - Fixed FF3 flashing line problem [zsKnight]
      - Fixed mysterious sprite disappearing bug in the new graphics engine
        [zsKnight]
      - Reduced noise in ToP opening theme.  It works fine in the DOS port,
        but the windows port still seems to produce some static, probably
        because of the way how sound is updated in that port. [zsKnight]
      - Updated Super 2xSaI and Super Eagle code (should be much faster
        now on MMX processors) [Kreed, added by pagefault]
      - Added gzip support [teuf]
      - Added support for ViBRA16 cards [Peter Santing]
      - No longer requires zlib.dll file, now statically linked. ZSNESw won't
        crash anymore if you try to load a .zip file without that dll file.
        [pagefault]
      - Now compiled using an optimising compiler [pagefault]
      - Almost a fully re-written DSP-1 emulation engine!
        [zsKnight, theoddone33, pagefault, teuf].  Also thanks to CrASH_Man
        for the 3x3 inverse matrix formula.
      - Fixed memory leak problem in the windows port during exit [pagefault]
      - And more ...


v1.17, Win v0.85
      - Added slow-down key.  You can configure it in Misc -> Game Keys
      - Invulnerability bug of the 3rd boss in Demon's Crest in the
        good checksum roms is fixed through rom mirroring
        I also noticed that this fix is the same as what the author of
        SNEeSe told me before about on some MegamanX1 roms, but I never had
        that rom so I never added this until now.  Guess that rom
        is also fixed too.
      - Changed memory initialization values - Lost Viking 2 works again
      - 65816: Fixed WAI instruction timing with HIRQ's
        Top Gear 2 - 2 player mode works now
      - Improved IRQ re-execution timing precision
      - Starfox 2 beta now runs with sound!
      - Fixed flickering problem in Starfox 2 beta
      - Added Mode 2 16x16 tile offset per tile mode
      - (Win32) Improved the timestamps on UDP headers.  This should
        (hopefully) solve those out of sync (where both sides see different
        things) problems with certain connections (ie. T1/LAN connections) in
        netplay.
      - (Win32) Added a big notice in netplay.txt.  For all of you who used
        netplay and had poor experiences with a ping time of less than
        300ms, read it!  Also added a more realistic system requirements
        description for decent netplay in netplay.txt rather than a cpu
        speed estimate.
      - Changed reverse stereo method to become invisible to the sound
        registers in emulation


v1.14, Win v0.80
      - Fixed configuration files from removing spaces from directory names
      - (DOS) Fixed 640x480 vesa2 scanline+interpolation display problem
      - (Win32) Improved Windows speed in 32-bit windowed mode.  Should
        give around an 18% speed increase in FPS.
      - (Win32) More netplay improvements.  Shouldn't be as jumpy when
        one side lacks input.
      - (Win32) Starting netplay will now force the max frameskip to 3
        if it is less than it and also force on auto frameskip.
      - (Win32) MMX optimised netplay with back buffer enabled.
      - (Win32) Fixed load state in netplay to load properly instead
        of sometimes stalling for no reason
      - (DOS) Accidently deleted the code to initialize IPX.  Fixed now.
      - Fixed a configuration loading problem when loading ZSNES from
        a different directory.
      - (Win32) Attempted to fix those out of sync problems (although
        I don't know if it's fixed now since those problems rarely happen
        to me)
      - (Win32) Displayed the current filename in the load window
        for those files with extra long names.
      - (Win32) Added nickname support to NetPlay.  There's a 9 character
        nickname size limit.
      - (Win32) Added actions to chat (similar to how mIRC works - use
        /me <action> )
      - (Win32) Nicknames can be changed in the windowed chat by typing
        /nick <new nickname>
      - Added a small buffer to the in-game chat to allow up to 5 chat
        strings displayed at once.
      - Local chat strings now appear in that buffer
      - Thickened black borders on the 5x5 font
      - Extended in-game chat length by around 30 characters
      - Fixed up Interpolation


v1.12, Win v0.74
      - (Win32) Hopefully fixed up those green display bugs in
        scanlines/2xSaI in 1:5:5:5 16bit modes.
      - (Win32) Improved lost packet recovery time and reduced the
        number of lost packet stalls in UDP netplay (should produce
        more fluid netplay)
      - (Win32) Fixed up crashing bug in Tales of Phantasia with a 512
        byte header
      - Extended filename length of the Quick Menu
      - (Win32) Hopefully fixed up the mouse wheel support for certain
        mice
      - Temp .ZIP directory is now cleared if it exists prior to another
        .ZIP file being loaded.
      - (Win32) Improved DirectInput error handling


v1.11, Win v0.72
      - (Win32) ZSNESw won't crash anymore if you don't have a soundcard
        or if DirectSound fails to initialize.
      - (Win32) Fixed a nasty performance bug with certain types of
        joystick/drivers installed, causing the FPS to be slower for
        no reason.
      - (Win32) Wrote an MMX optimised blitter for 16bit non-D windowed
        and full screen modes.
      - (Win32) Added simple wheel mouse support.


v1.10, Win v0.70
      - Fixed games that turns on the x239 resolution (eg. Chrono Trigger
        battles) when scanline mode is enabled
      - (Win32) Fixed up crashing bugs on extra long filenames with
        underscores
      - (Win32) Hopefully fixed the odd colored interpolation in 1:5:5:5 16bit
        color settings
      - (Win32) Hopefully won't crash anymore when the temporary directory
        exists prior to unzipping a .zip file
      - (Win32) Fixed loading of .zip files with more than 2 '.'s in the
        filename.  Thanks to DCX for helping us troubleshoot this.
      - (Win32) Fixed up short filename saveram/save states loading when
        the long filename has spaces in it.
      - Added TCP/IP Support.  It is recommended that for playable netplay,
        you'd have an average ping time of less than 300ms (type
        ping <ip address> in dos) and that packet loss is minimal for TCP/IP
        (not UDP).  At the moment, you cannot have more than 2 connections
        Thanks for all the testers for testing this, especially DooMStalK,
        GreenImp, and TeleKawaru!  Also added back buffer support.  This
        will sacrifice cpu power for netplay to make it much more playable.
        WARNING: High cpu speed recommendations (~450mhz+).
                 Please see netplay.txt for details.
      - Added save states to netplay (just use them like you normally do)
      - Save Ram is now defaulted to load/save on the server's side
        Save Ram are not supported in SA-1/SuperFX games due to their size,
        but you can use save states instead in that case.
      - Increased chat line length in the out-of-game chatbox by a lot
      - Partly increased the chat line length in-game
      - in-game chat text now stays longer on-screen by 2 seconds
      - Added reset in netplay
      - Fixed up movie recording feature
      - (Win32) Mouse shouldn't get stuck on the left side anymore.
      - (Win32) Video mode 3 (256x224FS) shouldn't crash anymore.  Thanks
        to kode54 for his assistance on the above 2 bugfixes.
      - (Win32) Fixed the instability bug where the window can sometimes
        start shaking for no reason and takes away windows resources.
      - (Win32) Re-wrote keyboard character input routines
      - Fixed up FF2(4)'s music in lower sampling rates
      - (Win32) Coded in the UDP protocol as a replacement for TCP/IP.
        Some network configurations won't work with UDP.  However, it is
        strongly recommended that you use UDP if you can because of the
        speed increase.  In order to disable UDP and use TCP/IP, both sides
        must de-select UDP.  
      - (Win32) Added a small multiplayer game list (multi.txt)
      - Added an updated Windows FAQ, courtesy of TuxedoMsk of VGNetwork
        who updated it.
      - Added a more user friendly input selection routine (changed Direct
        Input to Keyb/Joystick and it also auto-sets keyb/Joystick when you
        set a key)
      - Hopefully fixed up the sprite priority problems (eg. FF2/4's
        damage points)
      - (Win32) Added rewind support for up to 8 levels (in 8 second
        intervals) (NOTE: Windows Port only! - Sorry DOS Port users).  In
        order to activate this, assign a key to the Rewind Key in the
        Misc -> GameKeys option.
      Note: Netplay plays really nice as long as the net connection is not
            unstable, both sides have a fast cpu  (speed requirements depend
            on the game), and at least have a 28.8 connection.
      *** PLEASE READ ZSNESW.TXT IF YOU ARE STILL HAVING PROBLEMS WITH
          THE WINDOWS PORT

